#pragma once

#include <stdbool.h>
#include <stdint.h>

struct xl_node;

struct xor_list
{
    struct xl_node* prev;
    struct xl_node* curr;
};

// Initialized an xor list to be empty.
void xl_init(struct xor_list*);

// Frees all the memory associated with the given xor list.
void xl_destroy(struct xor_list*);

// Returns whether the list is currently empty.
bool xl_is_empty(struct xor_list*);

// Moves to the next position in the list.
void xl_forward(struct xor_list*);

// Moves to the previous position in the list.
void xl_back(struct xor_list*);

// Returns a pointer to the element in the current position.
int* xl_data(struct xor_list*);

// Inserts an element to the left of the current position, not changing
// the current position.
void xl_insert(struct xor_list*, int);

// Removes the element at the current position, moving to the
// next position.
void xl_remove(struct xor_list*);
